/* Several macros are needed to be defined before #include'ing this file: */
/* TON(i) is the frequency/pitch/whatever of the pitch i halftones over C */
/* VEL(i) is velocity (if used) of the same pitch */
/* PITCH_TYPE is float or int, depending what you need */

/* If you change the musicbox, you configuration needs to be changed */
/* below this line */

/* Major scale */
#define PPITCH(i) (((int)i)*2-((int)i+4)/7-((int)i)/7)

/* Convenience functions */
#define PITCH_NOTE(i) TON(PPITCH(i)),VEL(PPITCH(i))
#define PITCH_OCTAVE(i) \
  PITCH_NOTE(i),PITCH_NOTE(i+1),PITCH_NOTE(i+2),PITCH_NOTE(i+3),\
   PITCH_NOTE(i+4),PITCH_NOTE(i+5),PITCH_NOTE(i+6)

#define MAXPITCHES 20
#ifndef PITCH_NEED_INIT
PITCH_TYPE pitch[MAXPITCHES*2+2]={
  PITCH_OCTAVE(0),PITCH_OCTAVE(7),PITCH_OCTAVE(14)};

/* This is empty, because we don't need an init-func for only 20 pitches! */
#define PITCH_INIT
#else
PITCH_TYPE pitch[MAXPITCHES*2+2];

#define PITCH_INIT pitch_init()
void pitch_init(void)
{
  int i;
  for(i=0;i<MAXPITCHES;i++) {
    pitch[i*2]=TON(PPITCH(i)); pitch[i*2+1]=VEL(PPITCH(i)); }
}
#endif /* NEED_PITCH_INIT */

